/*	Sample program for Olimex MOD-IO with ATMEGA16L processor
 *	Using Hyper Terminal for input commands as follow:
 *	1) 1c<0x01>e  - TURN ON relay 1
 *	2) 1c<0x02>e  - TURN ON relay 2
 *	3) 1c<0x03>e  - TURN ON relay 3
 *	4) 1c<0x04>e  - TURN ON relay 4
 *	5) 1c<0x05>e  - TURN OFF relay 1
 *	6) 1c<0x06>e  - TURN OFF relay 2
 *	7) 1c<0x07>e  - TURN OFF relay 3
 *	8) 1c<0x08>e  - TURN OFF relay 4
 *	9) 1c<0x09>e  - READ AIN2-2 
 *	10) 1c<0x1A>e  - READ AIN2-1
 *	11) 1c<0x1B>e  - READ AIN1-3
 *	12) 1c<0x1V>e  - READ AIN1-2
 *	13) 1c<0x1D>e  - READ DIGITAL INPUTS
 *	Compile with AVRStudio 4.15+ WinAVR (gcc version 3.4.6)
 */


#include <avr/eeprom.h> 
#include <ctype.h>
#include <stdlib.h>
#include <avr/pgmspace.h>
#include "avr/io.h"
#include<string.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <util/delay.h>

//Password of the target//
const char password='1';

volatile char var;
volatile char flag_address=0;
 const unsigned char address=0x05;
volatile char buffer[8];
volatile unsigned char test;
volatile char string_analog[10]="0000000000";
unsigned char i=0;
#define command_on		flag_register = 0xFF
#define	command_off		flag_register = 0x00
int digital(void);
int action (void);
void Print(char Text[80]);
void PrintLine();
void PORT_Init();
void USART_Init( unsigned int ubrr);
unsigned char UART_Receive();
void UART_Transmit(unsigned char Data);
void PrintLn(char Text[80]);
volatile unsigned char u=0;
volatile	 unsigned char abba;
 volatile char result[10]="0000000000";
volatile long rezultat=0;
unsigned char i;
volatile char p,d; 
volatile char v[10];	  



unsigned  char	flag_register=0;

#define	__AVR_ATmega16__	1

#define FOSC 8000000 /* in Hz */
#define BAUD 9600
#define MYUBRR ((FOSC/16/BAUD)-1)

char Txt[80];
unsigned char Action = 0;
volatile uint16_t adcval;
volatile struct status {

	unsigned command:1;
	unsigned end:1;
	unsigned addres:1;
	}status_bits;

	//
char *masiv[]={


		"C<0x01>E",
		"C<0x02>E",
		"C<0x03>E",
		"C<0x04>E",
		"C<0x05>E",
		"C<0x06>E",
		"C<0x07>E",
		"C<0x08>E",
		"C<0x09>E",
		"C<0x1A>E",
		"C<0x1B>E",
		"C<0x1V>E",
		"C<0x1D>E"
				};
				
/*  Print new line to the Hyper Terminal */	
void PrintLine()
{
	UART_Transmit(10);
	UART_Transmit(13);
}

/*  PORT_Init */	
void PORT_Init()
{
	PORTA = 0b00000000;
	DDRA = 0b00001111;

	PORTB = 0b00000000;
	DDRB = 0b11111000;		

	PORTC = 0b00000000;
	DDRC = 0b11111111;

	PORTD = 0b00000000;
	DDRD = 0b11100010;		

	
	

}


/*  USART_Init */			

void USART_Init( unsigned int ubrr)
{
	/* Set baud rate */
	UCSRA = 0x00;
	
	/* Enable receiver and transmitter */
	UCSRB = (1<<RXEN)|(1<<TXEN)|(1<<RXCIE);
	/* Set frame format: 8data, 1stop bit */
	UCSRC = 0b10000110;
	
	UBRRH = (unsigned char)(ubrr>>8);
	UBRRL = (unsigned char)ubrr;
}


/* Read ANALOG inputs */

void analog(unsigned char channel) {


switch(channel) {

case 4: ADMUX=0b01100100, strcpy(Txt, "AIN2-2="),Print(Txt); break;
case 5: ADMUX=0b01100101, strcpy(Txt, "AIN2-1="),Print(Txt); break;
case 6: ADMUX=0b01100110, strcpy(Txt, "AIN1-3="),Print(Txt); break;
case 7: ADMUX=0b01100111, strcpy(Txt, "AIN1-2="),Print(Txt); break;

				}
	
			
		ADCSRA=0b10000111;
		SFIOR=0x00;

		
		ADCL=0;

	

		ADCH=0;

		ADCSRA|=0b01000000;

		
		while((ADCSRA&0b00010000)==0) {}

		for(unsigned char vag=200;vag;vag--) {}

		rezultat=(ADCH*13);

		 itoa((int)rezultat,string_analog,10);

		strcat(string_analog,"mV;");

		strcpy(Txt,string_analog);PrintLn(Txt); 
		

									}

/* Read DIGITAL inputs */

int digital(void)	{

	d=PIND&0b00001000;
	p=PINB&0b00000111;

	
	if(p&0b00000001) {

		strcpy(Txt,"DIGITAL_INPUT1=0;");PrintLn(Txt); 
					 }

		else{strcpy(Txt,"DIGITAL_INPUT1=1;");PrintLn(Txt);};
		
	if(p&0b00000010) {

		strcpy(Txt, "DIGITAL_INPUT2=0;"); PrintLn(Txt); 
					 }

		else{ strcpy(Txt, "DIGITAL_INPUT2=1;"); PrintLn(Txt);};

	if(p&0b00000100) {

		strcpy(Txt, "DIGITAL_INPUT3=0;"); PrintLn(Txt); 
					 }

		else{ strcpy(Txt, "DIGITAL_INPUT3=1;"); PrintLn(Txt);};



	if(d)			 {

		strcpy(Txt, "DIGITAL_INPUT4=0;"); PrintLn(Txt); 
					 }

		else {strcpy(Txt, "DIGITAL_INPUT4=1;");	PrintLn(Txt);};
						
						
						

					
	return 0;
					}
	

/* action finction */

 int action ()

{	

	
			
		char i=0;

		result[0]=0;
	
	for(i=0;i<10;i++) {result[i]=result[i+1];}
	result[8]='\0';

		for(unsigned char zar=0;zar<13;zar++) 	{


				
				
						if(!(strcasecmp(result,masiv[zar])))

								{

													
								switch(zar)	{

								case 0:PORTA|=0b00001000;break;
								case 1:PORTA|=0b00000100;break;
								case 2:PORTA|=0b00000010;break;
								case 3:PORTA|=0b00000001;break;
								case 4:PORTA&=0b11110111;break;
								case 5:PORTA&=0b11111011;break;
								case 6:PORTA&=0b11111101;break; 
								case 7:PORTA&=0b11111110;break;
								case 8:analog(4);break;
								case 9:analog(5);break;
								case 10:analog(6);break;
								case 11:analog(7);break;
								case 12:digital();break;
											}			
											
								}
												}
		
		for(unsigned char per=0;per<10;per++)

			{result[per]='\0';}					
																				
		SREG|=0b10000000;							
		test=0;
		return 0;				
}
	
/*  UART Recieve Interrupt */							

ISR(USART_RXC_vect)
{	 
   	

	result[u++]=UDR;
	
	if(u==9)			 {

	result[9]='\0';
	u=0;
	SREG&=0b01111111;
	PrintLine();

	var = eeprom_read_byte ((const uint8_t *)(0x00));
	if(result[0]==var) 

	{
	
	
	DDRD=0b11100010;
	UCSRB = (1<<RXEN)|(1<<TXEN)|(1<<RXCIE);	
	test=1;
	UCSRA&=0b01111111;
	return;

	 }

	
	
	UCSRB=0b10010000;
	DDRD=0b11100001;
	SREG|=0b10000000;
						}
	UCSRA&=0b01111111;	

	return 0;

}



/*  UART Receive */	

unsigned char UART_Receive()
{
	if (UCSRA & 0b10000000)
		return UDR;
	else
		return 0;
}

/*  UART Transmit */
	
void UART_Transmit(unsigned char Data)
{
	
	/* Wait for empty transmit buffer */
	
	while ( !( UCSRA & (1<<UDRE)) ){}
	/* Put data into buffer, sends the data */
	UDR = Data;
}

/*************************************** W R I T E  *****************************************/

//return Length of string
unsigned char Length(char Temp[80])
{
	unsigned char L=0;
	while (Temp[L]) L++;
	return L;
}

//print text
void Print(char Text[80])
{
	unsigned char Len, i, T;
	Len = Length(Text);
	for (i=0; i<Len; i++)
	{
		
		T = Text[i];

		
		UART_Transmit(T);
	}
	strcpy(Text, "");
}

//print text and new line
void PrintLn(char Text[80])
{
	unsigned char Len, i, T;
	Len = Length(Text);
	for (i=0; i<Len; i++)
	{
		T = Text[i];
		UART_Transmit(T);
	}
	strcpy(Text, "");
	UART_Transmit(13);
	UART_Transmit(10);
}



//print welcome message

void Print_Welcome()
{
	PrintLine();
	strcpy(Txt, "************************"); PrintLn(Txt);
	strcpy(Txt, "*       AVR MOD-IO     *"); PrintLn(Txt);
	strcpy(Txt, "* (C) 2010, OLIMEX Ltd *"); PrintLn(Txt);
	strcpy(Txt, "************************"); Print(Txt);
}

//print Commands

void Print_Commands()
{
	PrintLine();
	strcpy(Txt, "1c<0x01>e  - TURN ON relay 1"); PrintLn(Txt);
	strcpy(Txt, "1c<0x02>e  - TURN ON relay 2"); PrintLn(Txt);
	strcpy(Txt, "1c<0x03>e  - TURN ON relay 3"); PrintLn(Txt);
	strcpy(Txt, "1c<0x04>e  - TURN ON relay 4"); PrintLn(Txt);
	strcpy(Txt, "1c<0x05>e  - TURN OFF relay 1"); PrintLn(Txt);
	strcpy(Txt, "1c<0x06>e  - TURN OFF relay 2"); PrintLn(Txt);
	strcpy(Txt, "1c<0x07>e  - TURN OFF relay 3"); PrintLn(Txt);
	strcpy(Txt, "1c<0x08>e  - TURN OFF relay 4"); PrintLn(Txt);
	strcpy(Txt, "1c<0x09>e  - READ AIN2-2"); PrintLn(Txt);
	strcpy(Txt, "1c<0x1A>e  - READ AIN2-1"); PrintLn(Txt);
	strcpy(Txt, "1c<0x1B>e  - READ AIN1-3"); PrintLn(Txt);
	strcpy(Txt, "1c<0x1V>e  - READ AIN1-2"); PrintLn(Txt);
	strcpy(Txt, "1c<0x1D>e  - READ DIGITAL INPUTS"); PrintLn(Txt);


}
/*********************************** M A I N ********************************/

int main(void)

{

	 eeprom_is_ready();



	eeprom_write_byte ((uint8_t *)(0x00), (uint8_t)(password));

	PORT_Init();

	USART_Init (MYUBRR);


	test=0;

	Print_Welcome();
	Print_Commands();
	PrintLine();

	sei();


	
		while(1)		{

			
			if (test!=0)
			
					{

					
					action();
					test=0;

					}

						}
	return 0;				
}



